<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Documentación del proyecto</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link href="https://fonts.googleapis.com/css?family=Nunito+Sans:300,400,600,700,800,900" rel="stylesheet">
    <link rel="stylesheet" href="Doc-2.css">
    <link rel="stylesheet" href="Doc-1.css">

  </head>
  <body>
    <div class="doc__bg"></div>
    <nav class="header">
      <h1 class="logo">GitLab <span class="logo__thin">Documentación</span></h1>
      <ul class="menu">
        <div class="menu__item toggle"><span></span></div>
        <li class="menu__item"><a href="https://gitlab.com/rodrigo.salazar.uach/control-asistencia" class="link link--dark"><i class="fa fa-github"></i> GitLab</a></li>
        <li class="menu__item"><a href="index.html" class="link link--dark"><i class="fa fa-home"></i> Principal</a></li>
      </ul>
    </nav>
    <div class="wrapper">
      <aside class="doc__nav">
        <ul>
          <li class="js-btn selected">Introducción</li>
          <li class="js-btn">Marco Teórico</li>
          <li class="js-btn">Problematica</li>
          <li class="js-btn">Librerías Importantes</li>
          <li class="js-btn">Metodología</li>
          <li class="js-btn">Modulo de funciones</li>
          <li class="js-btn">Modulo principal</li>
          <li class="js-btn">Rendimiento y visualización</li>
          <li class="js-btn">Referencias</li>
        </ul>
      </aside>
      <article class="doc__content">
        <section class="js-section">
          <h3 class="section__title">PROTOTIPO DE CONTROL Y REGISTRO EN LA ASISTENCIA MEDIANTE RECONOCIMIENTO FACIAL</h3>
          <p>Se propuso un sistema de reconocimiento facial para el monitoreo y control en la entrada de empleados en una empresa o institución. 
            El sistema esta desarrollado en lenguaje de programación python ocupando las librerías face_reconigtion y OpenCV. Este sistema esta desarrollado para
            detectar rostros humanos mediante una web-cam y buscar coincidencias en una carpeta de imagenes registrada con los rostros de cada  empleados de la empresa. 
            El sistema general funciona como se presenta en la siguiente figura </p>


         
          <h3 class="section__title">Introducción</h3>
          <p>Rodeados por una sociedad en continuo cambio y con un afán de desarrollo tecnológico sin límites, la inteligencia computacional se posiciona como una de las áreas que mayor repercusión está teniendo actualmente. 
            Dentro de este contexto, se encuentra el reconocimiento facial, una herramienta cada vez más usada en cualquier ámbito o en cualquier situación; desde el desbloqueo de dispositivos móviles, pasando por cientos 
            de aplicaciones, hasta su uso como medida de seguridad tomada por algunos gobiernos.</p>
        
        <hr />
        </section>
        <section class="js-section">
          <h3 class="section__title">MARCO TEÓRICO</h3>
          <h3 class="section__title">Biometría</h3>
          <p>La biometría es la aplicación de técnicas estadísticas y matemáticas sobre las características físicas
            estáticas de los individuos para determinar o verificar su autenticidad.</p>
          <p>Cuando se habla de una persona es importante distinguir entre características físicas estáticas o
            dinámicas. Estas últimas incluyen factores de comportamiento, como bien pueden ser una firma, la
            forma de teclear o la forma de caminar. Por su propia naturaleza, son fáciles de suplantar, ya que no
            se tratan de características intrínsecas al cuerpo humano, propias de su fisiología. Es por este motivo
            que cuando se habla de biometría se utilizan las características físicas estáticas, aquellas únicas,
            inamovibles y propias de cada ser vivo.</p>

          <h3 class="section__title">Visión Artificial</h3>
          <p>La visión por computador o visión artificial es el conjunto de herramientas y procesos que se utilizan
            para adquirir, procesar, analizar y modificar imágenes del mundo real con el objetivo de poder ser
            tratadas por un ordenador.</p>
          <p>Actualmente, una de las principales funciones para las que se utiliza la visión por computador es el
            reconocimiento y análisis de objetos en imágenes y videos, pero también tiene aplicación en campos
            como la industria, la medicina o la conducción autónoma.</p>
          <h3 class="section__title">Reconocimiento Facial</h3>

          <p> Un sistema de reconocimiento facial permite obtener de forma automática la identidad de una
            persona a partir del análisis de sus características faciales extraídas de una imagen o fotograma digital,
            gracias a su comparación con una base de datos. Para llevar a cabo este proceso se utiliza la inteligencia
            artificial, y, en función de las técnicas empleadas, de los recursos disponibles y de los potenciales
            objetivos, el reconocimiento facial se puede implementar a través de diferentes ramas de la IA.
            A día Por lo que respecta a los métodos empleados en este proyecto; Fisherfaces, Eigenfaces y LBPH, es
            importante marcar que se encuentran en el área del machine learning, concretamente en el
            aprendizaje supervisado, conjuntamente al uso de la tecnología de visión por computador. En este caso
            no se ha utilizado el deep learning porque los métodos actuales basados en machine learning son
            bastante eficientes y ofrecen resultados buenos sin consumir una ingente cantidad de recursos de
            memoria y de procesamiento, además de facilitar su implementación.
          </p>
          
          <p> El funcionamiento de un sistema de reconocimiento facial se centra en cinco procesos:</p>
          <ul>

            <li> Adquisición de la imagen</li> <p> Se captura la imagen, bien sea a partir de la toma de una fotografía
                o de la extracción de un fotograma de un vídeo.</p>

            <li> Detección de la cara</li> <p> Se detectan los rostros existentes en la imagen.</p>

            <li> Acondicionamiento de la imagen</li> <p> El objetivo es que todas las imágenes con las que se trabaja
                tengan características similares. Habitualmente se utiliza la rotación para que los rasgos
                faciales estén alineados, además de la ecualización del histograma para eliminar contrastes
                excesivos y defectos de iluminación. Además, según convenga, se pueden aplicar técnicas para
                eliminar ruido de la imagen, o para recortarla y obtener un tamaño igual en todas las
                imágenes. Todas las imágenes se transforman a escala de grises.</p>

            <li> Extracción de características</li> <p> Se procesa la imagen para obtener las características que
                distinguen una cara de otra.</p>

            <li> Algoritmo de reconocimiento</li> <p> Aplicando el algoritmo de reconocimiento, se comparan los
                resultados con la base de datos para obtener la identidad de la persona en cuestión.</p>

          </ul>

        <h3 class="section__title">Inteligencia computacional</h3>
        <p>El concepto de inteligencia artificial fue introducido en 1956 por John McCarthy, un reconocido
          informático que destacó en el campo de las Ciencias de la Computación y que recibió el premio Turing
          en 1971. Él mismo definió la inteligencia artificial como “la ciencia e ingenio de hacer máquinas
          inteligentes, especialmente programas de cómputo inteligentes”.</p>
        <p>Actualmente, la inteligencia artificial se encuentra en constante desarrollo y evolución, y cada vez se
          dedican más recursos a ello, debido a que hoy en día su uso tiene aplicación casi en cualquier campo.</p>

        <p>Dentro de la inteligencia artificial cabe destacar la existencia de varias ramas, como el machine
          learning, el deep learning, las redes neuronales y la visión por computador, entre muchas otras.</p>

        <p>El machine learning (o aprendizaje automático) se define como la capacidad que tiene una máquina o 
          un software para aprender a partir de una base de datos, con el objetivo de tomar una decisión correcta 
          sin la intervención de una persona. Este proceso se realiza principalmente a través de la programación 
          de algoritmos y funciones matemáticas, aunque también toma una gran importancia el uso de la estadística. 
          Existen tres tipos de machine learning, el aprendizaje supervisado, el aprendizaje no supervisado y el
          aprendizaje por refuerzo:</p>

          <ul>

            <li>Aprendizaje Supervisado</li> <p> Este tipo de aprendizaje se basa en proporcionar a la máquina una base 
              de datos con entradas y sus salidas correspondientes, o dicho de otra forma, se proporciona la relación 
              entre las entradas y las salidas para que aprenda de ella.
              Si se quiere entrenar al algoritmo para que reconozca, por ejemplo, a animales, entonces se
              proporciona una base de datos con imágenes de cada animal, y cada imagen estará etiquetada con el
              nombre de su respectivo animal. De esta manera, el objetivo será que la máquina sea capaz de
              determinar qué animal es a partir de su imagen.</p>

            <li> Aprendizaje no Supervisado</li> <p> En este caso todo el proceso se realiza sobre un conjunto de 
              datos formado solamente por entradas al sistema. No se tiene información sobre las etiquetas de esos datos. 
              El sistema se basa en el reconocimiento de patrones para poder agrupar los datos en función de sus características 
              y así poder clasificarlos.</p>

            <li> Aprendizaje por Refuerzo</li> <p> Este tipo de machine learning se basa en el aprendizaje a partir del 
              método prueba-error. El algoritmo se realimenta constantemente de los resultados obtenidos en las acciones 
              que realiza, y trata de optimizar el resultado en cada iteración.</p>


          </ul>

        <p> Este tipo de machine learning se basa en el aprendizaje a partir del 
              método prueba-error. El algoritmo se realimenta constantemente de los resultados obtenidos en las acciones 
              que realiza, y trata de optimizar el resultado en cada iteración.</p>
            
      
        <h3 class="section__title">Redes Artificiales Convolucionales</h3>

        <p>El deep learning (o aprendizaje profundo) esta constituida por estructuras lógicas que intentan asemejarse
          al sistema cognitivo de un ser humano, poseyendo múltiples capas o unidades de proceso, cada una
          de ellas formada por un algoritmo de machine learning. </p>
        
        <!-- <hr />
        </section>
        <section class="js-section">
          <h3 class="section__title">ESTADO DEL ARTE</h3>
          <h3 class="section__title">reconocimiento facial China</h3>
          <p>gdgdfgdfgdfgdf</p>
          <p>fdsfdsfdsfdsfsdfsdfs</p> -->
          <section class="js-section">
            <h3 class="section__title">PROBLEMATICA</h3>
          <p>En muchas empresas  e industrias que disponen de una jornada laboral completa o parcial, con horarios dinámicos y extensos, la asistencia siempre 
            a sido un valor importante para el orden y el rendimiento de la empresa, sobre todo para aprovechar al máximo cada minuto de desempeño. La asistencia 
            actualmente se controla mediante la inclusión de los datos del empleado mediante un texto escrito en un libro o a través de monitoreo utilizando personal 
            encargado tales como “recursos humanos” o guardias de seguridad mediante de cámaras en tiempo real, monitoreando la puntualidad de sus trabajadores. Tener 
            el registro de asistencia en una empresa es importante y en muchas ocasiones se vuelve un problema si es que no se respetan los contratos y sobre todo cuando 
            esto acarrea efectos de desorden y bajo compromiso con la empresa. Ademas, tener un encargado que observe la puntualidad de sus trabajadores, podría generar 
            “tiempos muertos”, ocupando tiempo innecesario de la cual se podría utilizar en otra actividad. 
            <BR>
            Otro aspecto beneficioso, es la seguridad del recinto, dado que es de vital importancia monitorear no solamente a los empleados de la empresa ya registrados, 
            sino que aquellas personas que son ajenas al recinto, para informar de forma detallada si aquel identidad detectada corresponde in situ a un empleado del lugar. 
            Esto supone un problema cuando la empresa es a mayor escala de trabajadores, dado que los procesos de identificación, autorización y registro, para el acceso de 
            aquellas identidades podrían ser lentos y ambiguos, haciendo que la estancia de aquella persona sea negativa e inhóspita.</p>

        <section class="js-section">
            <h3 class="section__title">LIBRERÍAS PYTHON IMPORTANTES</h3>

            
            <center><a href='https://postimg.cc/YjzzMJN7' target='_blank'><img src='https://i.postimg.cc/1RLCcSf8/lib1.png' border='0' alt='lib1' width="600"/></a></center>
            
            <h3 class="section__title">face_reconigtion</h3>

            <p>face_recognition es una libreria de python basada en dlib y deep learning. Es sencilla en la aplicación y permite realizar seguimiento facial desde una carpeta de imagenes
             referencial, en donde el modelo tiene precisión del 99,33%. Los paquetes de face_recognition se definen como: </p>

             <p> <b>face_locations:</b> Es un metodo que localiza el rostro de una img y lo devuelve una matriz de cuadros delimitadores de rostros humanos 
              en una imagen. Generalmente es paquete devuelve una lista de tuplas de ubicaciones de caras encontradas en orden css 
              (arriba, derecha, abajo, izquierda).
            </p>

             <div class="code__block code__block--notabs">
              <pre class="code code--block">
                <code>
                  face_recognition.api.face_locations (imagen, n_muestreo, modelo)
                </code>
              </pre>
            </div>

            <p>
              <b> Parametros:</b>
              <BR>
                <BR>
              imagen: Es una imagen que viene relacionada a una matriz en numpy
              <BR>
                <BR>
              n_muestreo: Cuántas veces se aumenta la muestra de la imagen en busca de caras. Los números más altos encuentran caras más pequeñas. 
              <BR>
                <BR>
              modelo: Qué modelo de detección de rostros usar. "hog" es menos preciso pero más rápido para el procesamiento en la CPU. "cnn" es más 
              preciso, utiliza un modelo de deep Learning que viene acelerado por GPU/CUDA. Si no se agrega ninguna clase de modelo "hog" viene predeterminado. 
            </p>


            <p> <b>face_encodings:</b> Es un metodo que al presentar una imagen, devuelve la codificación facial de 128 dimensiones para cada rostro de la imagen.
              Este metodo devuelve una lista de codificaciones de caras de 128 dimensiones (una para cada cara en la imagen). 
            </p>

             <div class="code__block code__block--notabs">
              <pre class="code code--block">
                <code>
                  face_encodings (imagen_cara, ubicacion_cara, n_codi, modelo)
                </code>
              </pre>
            </div>
            <p>
             <b>Parametros:</b> 
              <BR>
                <BR>
              imagen_cara: Corresponde a la imagen que contiene una o más caras 
              <BR>
                <BR>
              ubicacion_cara: Los cuadros delimitadores de cada cara si ya los conoce (opcional).
              <BR>
                <BR>
              n_codi: cuántas veces se vuelve a muestrear la cara al calcular la codificación. Más alto es más preciso, 
              pero más lento (es decir, 100 es 100 veces más lento).
              <BR>
                <BR>
              modelo: Se pueden usar los modelos "large" o "small". El modelo "small" es predeterminado Y solo devuelve 5 puntos por lo que lo hace
              más rápido en el procesamiento del cpu.
            </p>

 

            <p><b>compare_face:</b> Realiza una comparacion de una lista de codificaciones faciales, utilizando una codificación candidata para ver si coinciden. 
              Generalmente esta lista de codificación faciales esta ya incluida en algun registro interno. Este metodo devuelve una lista de valores de verdadero/falso 
              entre cada comparación. 
            </p>

             <div class="code__block code__block--notabs">
              <pre class="code code--block">
                <code>
                  compare_faces (caras_conocidas, caras_comprobar, tolerancia)
                </code>
              </pre>
            </div>

            <p>      
              <b>Parametros:</b>
              <BR>
              <BR>
              caras_conocidas: Corresponde a la lista de codificaciones de rostros conocidas. 
              <BR>
              <BR>

              caras_comprobar: Corresponde a la codificación de una sola cara para comparar con la lista de caras ya conocidas.
              <BR> 
              <BR>
              tolerancia: Es la distancia entre las caras para considerarlo como una coincidencia, mientras más bajo sea el valor es más estricto. 
              Un valor de 0,6 es un estandar típico de rendimiento. 
          
            </p>     
  


            <p><b>face_distance:</b> Dada una lista de codificaciones de caras (en un registro de datos), se realiza la comparación con una codificación de caras conocidas,
              en donde se obtiene una distancia euclidiana para cada cara de comparación. La distancia te dice qué tan similares son las caras. Devuelve un ndarray 
              numpy con la distancia para cada cara en el mismo orden que la matriz de 'caras'
            </p>

             <div class="code__block code__block--notabs">
              <pre class="code code--block">
                <code>
                  face_distance(lista_codi , cara_comparar )
                </code>
               </pre>
             </div>
             <p>
             <b>Parametros:</b> 
              <BR>
                <BR>
              lista_codi: Lista de codificaciones faciales para comparar, ubicadas en algun registro.
              <BR>
                <BR>
              cara_comparar: una codificación facial para comparar (generalmente obtenida desde una imagen).
             </p>

    

            <h3 class="section__title">open_cv</h3>

            <p>OpenCV es una biblioteca de Python que le permite realizar tareas de procesamiento de imágenes y visión artificial. 
              Proporciona una amplia gama de funciones, que incluyen detección de objetos, reconocimiento facial y seguimiento. </p>
            
          </section>
        
          <h3 class="section__title">Otras Librerías</h3>

            <p><b>Pyttsx3:</b> Es una biblioteca de conversión de texto a voz en Python. A diferencia de las bibliotecas alternativas, 
              funciona sin conexión y es compatible con Python 2 y 3. </p>

            <p><b>Datatime:</b> El módulo Python Datetime proporciona clases para trabajar con fecha y hora. Estas clases proporcionan una serie de 
              funciones para tratar con fechas, horas e intervalos de tiempo. La fecha y la fecha y la hora son un objeto en Python, por lo 
              que cuando los manipula, en realidad está manipulando objetos y no cadenas o marcas de tiempo.  </p>

            <p><b>Numpy:</b> NumPy es una biblioteca de Python utilizada para trabajar con matrices.También tiene funciones para trabajar en el dominio del 
              álgebra lineal, la transformada de Fourier y las matrices.  </p>
            
            <p><b>Cprofile:</b> cProfile es una biblioteca avanzada que realiza un seguimiento de las funciones para generar una lista de las funciones llamadas 
              con más frecuencia. cProfile es beneficioso para el desarrollo, dado que Proporciona una biblioteca estándar, realiza un seguimiento de diferentes 
              estadísticas de comportamiento de llamadas y los desarrolladores pueden usarla sin restricciones.  </p>
          

          <hr />
        </section>
        <section class="js-section">
          <h3 class="section__title">METODOLOGÍA</h3>


          <p>El sistema completo es relativamente sencillo de entender, sin embargo los estados están determinado de una variedad de procesos, con tal 
            de lograr un buen equilibrio en el desempeño del reconocimiento facial. En el diagrama de flujo de la Fig. 1 se observa claramente como es 
            el funcionamiento del sistema propuesto. En un principio la interfaz de control es aquel proceso que busca controlar los estados de 
            encendido/apagado/pausa o de generación de informes de los empleados y  puede corresponder a una interfaz grafica o simplemente una interfaz 
            controlada por algún periférico de entrada en la computadora. La activación de la cámara sera permanente y estará siempre verificando si 
            existe un rostro en la imagen. En caso que encuentre algún rostro, el programa comenzara a realizar el seguimiento en tiempo real generando 
            un cuadro en la imagen y realizara una comparación del empleado con alguna imagen que este almacenada en los registros de datos de la empresa.  
            En caso que sea un empleado del lugar se almacenara su nombre, su hora de llegada en un registro de datos, en conjunto con la activación de 
            voz de un asistente. Sin embargo, en caso que el reconocimiento facial no corresponda a un empleado, también se activara una notificación de alerta. 
            Es importante destacar que el sistema, cualquier clase de proceso puede verse interrumpido mediante la interfaz de control.
          </p>

          <center><a href='https://postimg.cc/t1sx6cVs' target='_blank'><img src='https://i.postimg.cc/wBVcC8qQ/diagramaflujo.png' border='0' alt='diagramaflujo' width="500" /></a></center>
        
        <center><caption align = "fondo"> Figura 1. Diagrama de flujo del sistema. </caption></center>

          <p>El sistema esta compuesto de cinco bloques importantes, en donde el bloque inicial corresponde al de control y monitoreo de asistencia como se 
            puede apreciar en la fig. 2. Este bloque depende completamente del funcionamiento operacional de cada bloque descendente, encontrando a los 
            procesos de codificación, análisis y procesamiento del Hardware. Los módulos de funciones e interfaz grafica corresponden a bloques de código que 
            tienen como objetivo dar herramientas y control al modulo principal, aportando paquetes, librerías, clases, funciones modulo principal y operación 
            al sistema. Luego el rendimiento y la visualización de determinados procesos de funcionamiento en el sistema dependerán en gran medida de como 
            ayudamos a optimizar los procesos del modulo principal.
          </p>

        <center><a href='https://postimg.cc/sMXyDdtZ' target='_blank'><img src='https://i.postimg.cc/bw0vgqgL/diagrama-Bloques.png' border='0' alt='diagrama-Bloques' width="500" /></a></center>
       
      <center><caption align = "fondo"> Figura 2. Diagrama de bloques detallado del sistema. </caption></center>
     
      <section class="js-section"></section>
        <h3 class="section__title">MODULO DE FUNCIONES</h3>
        <p>    El bloque de funciones, es un bloque modular que contiene toda las clases y funciones de nuestro sistema, ademas de ser uno de 
          los paquetes más importantes. Estas funciones están disponibles para ser llamadas desde el modulo "principal" y en ella encontramos 
          las siguientes funciones y clases:
          
        <li>Funcion list_Personas</li>
        <li>Funcion codificar</li>
        <li>Clase facial</li>
        <li>Funcion generar_rec</li>
        <li>Funcion registrar_ingresos</li>
        <li>Funcion hablar</li>
        <li>Funcion testeo </li>
        <li>Funcion presionar_teclado</li>
          
        </p>

        <p><b>Lista de personas:</b></p>
        <p>
          Función encargada de cargar las imágenes de la ruta empleados como lista. Ademas es capaz de solo entregar 
          el nombre sin su extensión (o tipo de archivo), haciendo uso de la librería os mediante el método 
          splitext.
        </p>
        
        <center><a href='https://postimg.cc/941cWXfT' target='_blank'><img src='https://i.postimg.cc/zBYvFVZd/dib2.png' border='0' alt='dib2' width="600"/></a></center>

        <p><b>Codificación de Imagenes:</b></p>
        <p>
          Función que se utiliza para devolver una lista de imágenes codificadas de la ruta (o directorio) 
          empleados, el loop for permitirá que todas las imágenes del directorio sean codificadas. Para codificar las imágenes 
          para luego realizar la comparación, es necesario utilizar el método face_encodings de la clase face_recognition, 
          en donde dada una imagen, devuelve la codificación facial de 128 dimensiones para cada rostro de la imagen.
        </p>

      <center><a href='https://postimages.org/' target='_blank'><img src='https://i.postimg.cc/85TDCWVV/dib3.png' border='0' alt='dib3' width="500"/></a></center>

        <p><b>Metodo e instancias de la clase face_recognition:</b></p>
        <p>
          Clase para llamar métodos de la librería Face_recognition, encargadas de encontrar la localización facial,
          la codificación de las de la imágenes, la búsquedas de las coincidencias y distancias entre dos focos de imágenes o videos.
        </p>

      <center><a href='https://postimg.cc/jwGmTByP' target='_blank'><img src='https://i.postimg.cc/6q3XrX3j/dib4.png' border='0' alt='dib4' width="500" /></a></center>

        <p><b>Rectangulos Localizados:</b></p>
        <p>
          Esta función depende de la instancia de cara_localizada (ubicada en la clase facial), dado que al localizar un rostro en una imagen 
          se desplegara un rectángulo que hará seguimiento de dicho rostro ocupando el método cv2 de openCV. Para localizar dicho 
          rostro es necesario tener activa la imagen o cámara, que en este caso se llamada mediante la variable img. La imagen tendrá 
          el nombre del empleado asociado, es por esto que se llamo al método putText de openCV, para agregar el nombre del empleado
          debajo del cuadrado generado en la localización de la cara
        </p>
        
      <center><a href='https://postimg.cc/N5vSzqsw' target='_blank'><img src='https://i.postimg.cc/kX2CDqLD/dib5.png' border='0' alt='dib5' width="500"/></a></center>

        <p><b>Registro de Empleados:</b></p>
        <p>
          Función que registra el nombre de la personas en un archivo registro.csv, integrando su nombre y la hora de llegada del empleado. 
          Ademas se incluyo un if para no adicionar los nombres ya inscrito en el registro, esto se logro introduciendo una variable nombres_registro
          que cumple la función de avisar si el nombre ya se encuentra en el registro.
        </p>

      <center><a href='https://postimages.org/' target='_blank'><img src='https://i.postimg.cc/1t3TTKQ4/dib6.png' border='0' alt='dib6' width="500"/></a></center>

        <p><b>Asistente de Voz:</b></p>
        <p>
          Funcion encargada de activar una asistente de voz cuando es este detecta en una camara la imagen de un empleado. 
          Se selecciono una voz en español latino y es llamada mediante el metodo setProperty(), realizando la accion de hablar 
          mediante el metodo say().
        </p>

      <center><a href='https://postimages.org/' target='_blank'><img src='https://i.postimg.cc/yYmMDxv1/dib7.png' border='0' alt='dib7' width="500"/></a></center>
     
      <section class="js-section">
        <h3 class="section__title">MODULO PRINCIPAL</h3>
        <p> Bloque principal encargado de activar la visualización y las acciones totales del sistema. Sin embargo desde este modulo se 
          llaman los metodologías de los demás módulos de paquetes, específicamente las funciones, clases y métodos. Loop infinito 
          que tiene como objetivos encontrar coincidencias y distancias mediante una base de datos que incluyen antecedentes previos 
          de los empleados. 
          Ademas esta integrado por un loop "while" principal, que funciona como intermediario entre las interacciones de los empleados 
          y la cámara, en donde se desea encontrar coincidencias y distancias desde un directorio que almacena imágenes que contienen los 
          rostros de los empleados. Se compone principalmente por la asignación de diferentes funciones y métodos relacionados con la 
          librería OpenCV, para activar procesos como la activación constante de la web-cam, como también la codificación de ciertas escenas 
          tomadas por la cámara. Ademas se hace llamado a constantes métodos y clases del paquete funciones, como es el caso de la clase 
          facial, la funciones codificar, list_empleados, hablar. etc.

        </p>

      <center><a href='https://postimg.cc/TLYgwPJX' target='_blank'><img src='https://i.postimg.cc/qR2L1htg/dib2-2.png' border='0' alt='dib2-2' width="600"></a></center>

        <p><b>Evaluación del Codigo mediante Cprofile:</b></p>
        <p>
          Además, se incluyo en este bloque una función que nos permite observar los tiempos y retardos en el proceso de ejecución de las funciones, clases o métodos. 
          En este caso se aplico Cprofile a la mayoría de las funciones del modulo funciones, para poder evaluar una probabilidad de reducir los tiempos de ejecución del código
        </p>

      <center><a href='https://postimg.cc/S2v2xfKW' target='_blank'><img src='https://i.postimg.cc/7hxgXB8Q/dib2-3.png' border='0' alt='dib2-3' width="600"/></a></center>



    <section class="js-section">
      <h3 class="section__title">RENDIMIENTO Y VISUALIZACIÓN</h3>
      <p>
        El reconocimiento es efectuado conectando una cámara al ordenador, con tal de facilitar el proceso de reconocimiento de las personas que vayan accediendo al recinto. 
        Dado que este sistema corresponde a un prototipo funcional, se podría montar el sistema en la misma cámara “WebCam” del ordenador. Sin embargo en esta ocasión se integrará 
        un sustituto de cámara, con el móvil (celular) mediante el software DroipCam en modo de WiFi/LAN. Este software es gratuito para bajas gamma de resoluciones y versión de 
        paga para mayores calidades de video.  
      </p>

      <center><a href='https://postimg.cc/Hr9rygxW' target='_blank'><img src='https://i.postimg.cc/8zqMxkgv/expa.png' border='0' alt='expa' width="600"/></a></center>
      

      <p>
        Ya activada la cámara se procede a hacer correr el programa. Específicamente solo tenemos que empezar a integrar rostros frente la cámara y verificar que tan sensible y que tan 
        buen desempeño tiene el reconocimiento. Después de varias pruebas el proceso es bastante rápido, apenas incluimos rostros humanos captados por la cámara, el sistema fue capaz de 
        detectar sin ninguna clase de inconvenientes sobre dicha identidad, dando en detalle a quien pertenece aquella persona. Sin embargo, se observo que cuando la imagen del video tiene 
        una mayor resolución, los tiempos de codificación por parte de los métodos de face_reconigtion tienden a aumentar,  generando un considerable Delay en el video, pero que no afecta 
        en su totalidad en cuanto al reconocimiento sino mas bien el fluidez del video. Ademas el sistema es capaz de detectar hasta una cantidad mucho mayor de rostros en el video CR>2 
        sin afectar el rendimiento.
      </p>
      <center><a href='https://postimg.cc/RJ1BDv2N' target='_blank'><img src='https://i.postimg.cc/Zn250RcF/fot2.png' border='0' alt='fot2' width="600"/></a></center>
      <center><a href='https://postimg.cc/t1n8cXxp' target='_blank'><img src='https://i.postimg.cc/1zvPfXRn/fot1.png' border='0' alt='fot1' width="600"/></a></center>
      <p>
        Como anteriormente se anticipo, existe un registro de identidades que va almacenando todos las rostros captados por la cámara. En este caso, el registro se va generando con la 
        inclusión del nombre y la hora en la que fue captada dicha identidad en la cámara, en un archivo .csv.

      </p>

      <center><a href='https://postimages.org/' target='_blank'><img src='https://i.postimg.cc/qMc7pkKn/fot3.png' border='0' alt='fot3' width="600"/></a></center>

      <p>
        Para que los análisis de comparación y distancias por parte de los métodos y clases de la librería face_recognition se lleven a cabo, es necesario tener una carpeta referencial 
        que involucre todos los rostros interesados, para un posible análisis en la identificación del individuo. 

      </p>

      <center><a href='https://postimg.cc/YLF6csx4' target='_blank'><img src='https://i.postimg.cc/BbYMFWLC/emple.png' border='0' alt='emple' width="600"/></a></center>
     

 

        </section>

        <section class="js-section">
          <h3 class="section__title">Referencias</h3>


        </section>

      </article>
    </div>

    <footer class="footer">Archivos fuentes de <a href="https://gitlab.com/rodrigo.salazar.uach/control-asistencia" target="_blank" class="link link--light">GitLab</a>.</footer>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
    <script>hljs.initHighlightingOnLoad();</script>
    <script src="scri.js"></script>
  </body>
</html>